============
NanoCap 
============

Copyright (c) 2014 M. Robinson

Introduction
============

NanoCap provides both libraries and a standalone application for the construction 
of capped nanotubes of arbitrarily chirality and fullerenes of any radius. Structures 
are generated by constructing a set of optimal dual graph topologies which 
are subsequently optimised using a carbon interatomic potential. Combining 
this approach with a GUI featuring 3D rendering capabilities allows for the rapid 
inspection of physically sensible structures which can be used as input for 
molecular simulation. 

Requirements
============

NanoCap as a library with no GUI.
---------------------------------

* NumPy - Version 1.6.2
* Scipy - Version 0.11.0
* sqlite3 Version 2.6.0
* C compiler (e.g. GCC)
* Fortran compiler (e.g. GFortran)

NanoCap + GUI from source
-------------------------

* Qt - Version 4.8.5 
* PySide - Version 1.1.1 
* VTK - Version 5.8 

Licenses
========

NanoCap is distributed under the Creative Commons Attribution-NonCommercial 2.5 
License (http://creativecommons.org/licenses/by-nc/2.5/). For a full description 
of this license see LICENSE.txt. 

In addition, if NanoCap is used to produce published work please acknowledge the 
following papers: 

1. Robinson M, Suarez-Martinez I, Marks N. A. Generalized method for constructing 
   the atomic coordinates of nanotube caps. Phys. Rev. B 2013 87(15):155430. 
 
2. Robinson M. Marks N. A. NanoCap: A Framework for Generating Capped Carbon Nanotubes 
   and Fullerenes. Com. Phys. Comm. 2014 185(10):2519-2523
   
In the standalone version of NanoCap, the following libraries are bundled but not 
modified: 

* NumPy - Version 1.6.2
* Scipy - Version 0.11.0
* sqlite3 Version 2.6.0
* Qt - Version 4.8.5 
* PySide - Version 1.1.1 
* VTK - Version 5.8 

The distribution licenses associated with each of the above are given in the 'licenses' 
folder which is bundled with both the source code and standalone application. 

Each license is compatible with the Creative Commons Attribution-NonCommercial 2.5 
License. 

      subroutine nabor

      include "common.f90"

      parameter (rskin=0.10)
      dimension xold(nmax,3), dxx(3)
      save      xold

!+--------------------------------------------+
!|  Check to see if list needs recalculation  |
!+--------------------------------------------+
      if ((numstep.ne.0).and.(.not.special)) then
        rmovemax=0.0
        do i=1,natom
	  rmove=0.0
	  do ind=1,3
            rmove=rmove + (x(i,ind)-xold(i,ind))**2
	  end do
          rmovemax=max(rmovemax,rmove)
	end do

        if (dsqrt(rmovemax).lt.rskin) return
      end if

!+------------------------+
!|  Clear existing lists  |
!+------------------------+
      rcut=c0+2.0*rskin
      if (special) rcut=c0

      npair=0
      do i=1,natom
        num(i)=0
      end do

!+---------------------------------------------------+
!|  O(N^2) loop to create the list of indexed pairs  |
!+---------------------------------------------------+
      do i=1,natom-1
        do j=i+1,natom
	  do ind=1,3
            delta= x(i,ind) - x(j,ind)
            dxx(ind)=delta - box(ind)*dnint(delta/box(ind))
	  end do

!This if-block for non-orthogonal coordinate system
          if (computeshear) then
	    dxx(2)=dxx(2) + shear*dxx(3)
	  endif

	  rijsq=0.0
	  do ind=1,3
	    rijsq=rijsq + dxx(ind)*dxx(ind)
	  end do
	  rij=sqrt(rijsq)

	  !following exceptions for pseudo-hydrogen for C4H8
	  !if ((i.eq.6).and.(j.eq.13)) rij=rcut+1.0
	  !if ((i.eq.7).and.(j.eq.14)) rij=rcut+1.0

          if (rij.lt.rcut) then
            num(i)=num(i)+1
            num(j)=num(j)+1

	    near(i,num(i))=j
	    near(j,num(j))=i

            npair=npair+1
            ipair(npair)=i
            jpair(npair)=j

            inum(npair)=num(i)
            jnum(npair)=num(j)
          end if

        end do
      end do

!+-----------------------+
!| Check no NNN overflow |
!+-----------------------+
      numflag=0
      do i=1,natom
	if (num(i).gt.NNN) then
	  numflag=1
	  write(6,*) 'atom',i,' num(i)=',num(i)
	end if
      end do	
      if (numflag.eq.1) stop 'Increase NNN'

!+----------------------------+
!|  Save current coordinates  |
!+----------------------------+
      do i=1,natom
        do ind=1,3
          xold(i,ind)=x(i,ind)
        end do
      end do

      end

      subroutine printrings

      include "common.f90"

      character*80 exe,awk

      if (norings) return

!+------------------------------------------+
!| Write out coordinates in xyz file format |
!+------------------------------------------+
      open(unit=9,file='tmp.edip.xyz',status='unknown')
      write(9,*) natom
      write(9,*) 'EDIP',box(1)
      do i=1,natom
        write(9,*) 'C',(x(i,j),j=1,3)
      end do
      close(unit=9)

!+----------------------------------------------+
!| Create script to be read as stdin by Rings.x |
!+----------------------------------------------+
      open(unit=9,file='tmp.edip.stdin',status='unknown')
      write(9,*) 'tmp.edip.xyz'
      write(9,*) bondcutoff
      write(9,*) '12'
      close(unit=9)

!+---------------------------------------+
!| Execute shell command and tidy output |
!+---------------------------------------+
      write(6,*)
      exe="/usr/people/nigel/carbon/rings/Rings.x"
      awk="tail -14 | awk '{print ""#"",$0}'"
      call system(exe//" < tmp.edip.stdin | "//awk)
      call system("/bin/rm -f tmp.edip.xyz tmp.edip.stdin")

      end

      subroutine writexbs

      include "common.f90"

      dimension xx(NMAX,3)

!+------------------------------------------------+
!| Decide to print in.bs, in.mv or nothing at all |
!+------------------------------------------------+
      if (nsnap.ne.0) then
        do i=1,natom
          do ind=1,3
            if (xbspbc) then
	      xx(i,ind)=x(i,ind)-box(ind)*nint(x(i,ind)/box(ind))
	    else
	      xx(i,ind)=x(i,ind)
	    end if
	  end do
        end do

        if (numstep.eq.0)                 goto 100
	if (mod(numstep,abs(nsnap)).eq.0) goto 110
      end if
      return

!+-----------------+
!| Write out in.bs |
!+-----------------+
 100  call system("/bin/rm -f in.mv")
      open(unit=8,file='in.bs',status='unknown')
       write(8,120) ((xx(i,ind),ind=1,3),i=1,natom)
       write(8,*) 'spe! C 0.2 red'
       write(8,*) 'bonds C C 0 ',bondcutoff,' 0.07 grey'
       write(8,*) 'in!3'
       write(8,*) '* box=',(real(box(ind)),ind=1,3)
       write(8,*) 'tmat 1 0 0 0 0 1 0 1 0'
      close(unit=8)

      return

!+-----------------+
!| Write out in.mv |
!+-----------------+
 110  if (nsnap.lt.0) call system("/bin/rm -f in.mv")
      open(unit=8,file='in.mv',status='unknown',access='append')
       write(8,130) numstep,t*timetau,tempk
       write(8,140) ((xx(i,ind),ind=1,3),i=1,natom)
      close(unit=8)

 120  format('atom C ',3F9.3)
 130  format(/,'frame step=',I6,', time=',f7.3,' ps, temp=',f7.1,' K')
 140  format(3F9.3)

      end

      subroutine force

      include "common.f90"

!+-----------------------+
!| Get Number of Threads |
!+-----------------------+
      !ncpu=1
!$      ncpu=OMP_GET_MAX_THREADS()
      !print *, "fortran ncpus",ncpu
!+------------------------+
!| Clear temporary arrays |
!+------------------------+
      do icpu=1,ncpu
        u2i(icpu)=0.0
        u3i(icpu)=0.0
        udihi(icpu)=0.0
      end do

      do i=1,natom
      do ind=1,3
          do icpu=1,ncpu
            fxx(i,ind,icpu)=0.0
          end do
        end do
      end do

!+--------------------------+
!| Main loop over the atoms |
!+--------------------------+
      call distance
      call cutoff

!$OMP PARALLEL DO SCHEDULE(STATIC) PRIVATE(i)
      do i=1,natom
        call coordination(i)
        call pair(i)
        call triple(i)
      end do
!$OMP END PARALLEL DO

!+--------------------------+
!| Manually reduce energies |
!+--------------------------+
      u2=0.0
      u3=0.0
      udih=0.0
      do icpu=1,ncpu
        u2=u2 + u2i(icpu)
        u3=u3 + u3i(icpu)
        udih=udih + udihi(icpu)
      end do
      pe=u2+u3+udih

!+------------------------+
!| Manually reduce forces |
!+------------------------+
      do i=1,natom
        do ind=1,3
          fx(i,ind)=0.0
          do icpu=1,ncpu
            fx(i,ind)=fx(i,ind) + fxx(i,ind,icpu)
            !print *, "fortran force",fx(i,ind)
          end do
        end do
      end do

      end

      subroutine checkrij(i,j)

      include "common.f90"

      parameter (rskin=0.10)
      dimension dxx(3)

      rcut=c0+2.0*rskin
      if (special) rcut=c0

      do ind=1,3
        delta= x(i,ind) - x(j,ind)
        dxx(ind)=delta - box(ind)*dnint(delta/box(ind))
      end do

!This if-block for non-orthogonal coordinate system
      if (computeshear) then
       dxx(2)=dxx(2) + shear*dxx(3)
      endif

      rijsq=0.0
      do ind=1,3
        rijsq=rijsq + dxx(ind)*dxx(ind)
      end do
      rij=sqrt(rijsq)

      if (rij.lt.rcut) then
        num(i)=num(i)+1
        num(j)=num(j)+1

        near(i,num(i))=j
        near(j,num(j))=i

        npair=npair+1
        ipair(npair)=i
        jpair(npair)=j

        inum(npair)=num(i)
        jnum(npair)=num(j)
      end if

      end

      subroutine properties

      include "common.f90"

!+------------------------------------------------+
!| Calculate the Energy, Momentum and Temperature |
!+------------------------------------------------+
      mv=0.0
      eke=0.0

      do ind=1,3
        vxsum=0.0
        do i=ifix+1,natom
          vxsum=vxsum + vx(i,ind)
          eke=eke + 0.5*vx(i,ind)**2
        end do
        mv=mv + vxsum*vxsum
      end do

      mv=dsqrt(mv)
      tempk=eke/(dfloat(natom-ifix))*tfac

      end
 

      program pbc

      parameter (NMAX=10000,cutoff=1.85)

      dimension    x(NMAX,3),nn(NMAX), box(3), nnn(10)
      character*80 arg1,arg2,arg3,arg4

!+-----------------------------------------+
!| Parse command line and read coordinates |
!+-----------------------------------------+
      call getarg(1,arg1)
      call getarg(2,arg2)
      call getarg(3,arg3)
      call getarg(4,arg4)

      read(arg1,*) natom
      read(arg2,*) box(1)
      read(arg3,*) box(2)
      read(arg4,*) box(3)

      write(6,*) 'natom=',natom

      do i=1,natom
        read(5,*) (x(i,ind),ind=1,3)
      end do

!+----------------------+
!| Compute coordination |
!+----------------------+
      do i=1,natom
        nn(i)=0
      end do

      do i=1,natom
        do j=i+1,natom
	  rijsq=0
	  do ind=1,3
	    dx= x(i,ind)-x(j,ind)
	    dx=dx - box(ind)*nint(dx/box(ind))
	    rijsq=rijsq + dx*dx
	  end do
	  rij=sqrt(rijsq)

          if (rij.lt.cutoff) nn(i)=nn(i)+1
          if (rij.lt.cutoff) nn(j)=nn(j)+1
	end do
      end do

!+---------------------------------+
!| Compute coordination statistics |
!+---------------------------------+
      do i=1,10
        nnn(i)=0
      end do

      do i=1,natom
        if (nn(i).le.1) nn(i)=1
        if (nn(i).ge.5) nn(i)=5
	nnn(nn(i))= nnn(nn(i)) + 1
      end do

      do i=1,5
        write(6,100) i,real(nnn(i))/natom * 100
 100    format('%nn',i1,'= ',F6.2)
      end do

!+-------------------+
!| Write pbc.bs file |
!+-------------------+
      open(unit=7,file='pbc.bs',status='unknown')
      do i=1,natom
	do ind=1,3
          x(i,ind)=x(i,ind) - box(ind)*nint(x(i,ind)/box(ind))
          !x(i,ind)=x(i,ind) - box(ind)*(nint(x(i,ind)/box(ind)-0.5)+0.5)
	end do

	write(7,110) nn(i),(x(i,ind),ind=1,3)
 110    format('atom C',i1,3F10.3)
      end do

      write(7,*) 'spe!C1 0.25 black'
      write(7,*) 'spe!C2 0.25 red'
      write(7,*) 'spe!C3 0.25 green'
      write(7,*) 'spe!C4 0.25 blue'
      write(7,*) 'spe!C5 0.25 orange'
      write(7,*) 'in!3'

      write(7,120) cutoff
 120  format('bonds * * 0 ',F5.2,' 0.075 0.8')

      end

      subroutine checkcell(i,ix,iy,iz,jstart)

      include "common.f90"

      ! Wrap-around indices of the cells
      if (ix.eq.0) ix=numcells(1)
      if (iy.eq.0) iy=numcells(2)
      if (iz.eq.0) iz=numcells(3)

      if (ix.gt.numcells(1)) ix=1
      if (iy.gt.numcells(2)) iy=1
      if (iz.gt.numcells(3)) iz=1

      ! Loop over the required atoms in the cell
      do jloop=jstart,ncell(ix,iy,iz)
        j=icell(ix,iy,iz,jloop)

        call checkrij(i,j)
      end do

      end

      subroutine stress(i,jj,fij,ind)

      include "common.f90"
      logical inrange
      if (.not.calcstress) return
      if (numstep.eq.0) return

      if (i.eq.0) then
        nstress=nstress + 1
        do j=1,natom
          if (inrange(x(j,3))) then
            do in1=1,3
            do in2=1,3
              totstr(in1,in2)=totstr(in1,in2) + vx(j,in1)*vx(j,in2)
            end do
            end do
          end if
        end do

          fac= 160.219 / vol / nstress

!        write(6,*) 'end of loop over atoms in stress'

          biaxial=0.0
          pressure=0.0
!        write(6,*)totstr(1,1),totstr(2,2),totstr(3,3),biaxial,pressure
          do in1=1,3
           pressure=pressure + fac*totstr(in1,in1)
           if (in1.eq.2) biaxial=pressure/2.0
          end do
      
          pressure=pressure/3.0
!        write(6,*) pressure,biaxial

      else
        j=near(i,jj)
        zav= 0.5*(x(i,3) + x(j,3))
        if (inrange(zav)) then
          do in2=1,3
            totstr(ind,in2)=totstr(ind,in2) - fij*dx(i,jj,in2)
          end do
        end if

      end if
      end

!=====================================

      function inrange(zval)

      include "common.f90"
      logical inrange

      inrange=.false.
      if (smin.gt.smax)                      inrange=.true.
      if ((zval.gt.smin).and.(zval.lt.smax)) inrange=.true.

      end

      subroutine printinput

      include "common.f90"

      WRITE(6,100)
      WRITE(6,110) NPASS
      WRITE(6,120) NTAKOF
      WRITE(6,130) NPRINT
      WRITE(6,140) NSNAP

      do i=1,npass
        write(6,150) varlist(i,1)
        write(6,160) (int(varlist(i,j)),j=2,4)
        write(6,170) (int(varlist(i,j)),j=5,6)
      end do

 100  FORMAT(/,'Three dimensional EDIP/Z/pi potential for carbon',/)
 110  FORMAT('NPASS=',I2)
 120  FORMAT('NTAKOF=',I1)
 130  FORMAT('NPRINT=',I3)
 140  FORMAT('NSNAP=',I4)

 150  FORMAT('H=',F7.5)
 160  FORMAT('  NSTEP=',I6,'  STARTT=',I5,'  ITHERM=',I1)
 170  FORMAT('  IGR=',I1,'  IMSD=',I1)

      end

      subroutine parse(line,value,error)

      include "common.f90"

      character(len=*) line, value
      logical error

      !print *, "fortran parse ",line,value,error
      error=.false.
      !print *,"call parse ", line,value,error,index(line,'bondcutoff=')
!+-----------------------------------+
!| Parameters for EDIP two-body term |
!+-----------------------------------+
      if (index(line,'aa=').eq.1) then 
        read(value,*,err=100) aa
      elseif (index(line,'bb=').eq.1) then 
        read(value,*,err=100) bb
      elseif (index(line,'beta=').eq.1) then 
        read(value,*,err=100) beta
      elseif (index(line,'sigma=').eq.1) then 
        read(value,*,err=100) sigma
      elseif (index(line,'a1=').eq.1) then 
        read(value,*,err=100) a1
      elseif (index(line,'a2=').eq.1) then 
        read(value,*,err=100) a2
    
!
!      elseif (index(line,'NMAX=').eq.1) then
!        read(value,*,err=100) NMAX
!      elseif (index(line,'NNN=').eq.1) then
!        read(value,*,err=100) NNN
!      elseif (index(line,'MAXCELL=').eq.1) then
!        read(value,*,err=100) MAXCELL
!      elseif (index(line,'MAXINCELL=').eq.1) then
!        read(value,*,err=100) MAXINCELL
!      elseif (index(line,'MAXCELL1=').eq.1) then
!        read(value,*,err=100) MAXCELL1
!+-------------------------------------+
!| Parameters for EDIP three-body term |
!+-------------------------------------+
      elseif (index(line,'gamma=').eq.1) then 
        write(*,*) "read gamma", gamma
        read(value,*,err=100) gamma
      elseif (index(line,'qq=').eq.1) then 
        read(value,*,err=100) qq
      elseif (index(line,'xlam=').eq.1) then 
        read(value,*,err=100) xlam
!    elseif (index(line,'pilam=').eq.1) then 
!      read(value,*,err=100) pilam
      elseif (index(line,'xmu=').eq.1) then 
        read(value,*,err=100) xmu

!+-----------------------------------------+
!| Parameters for generalised coordination |
!+-----------------------------------------+
      elseif (index(line,'zrep=').eq.1) then 
        read(value,*,err=100) zrep
      elseif (index(line,'zrep2=').eq.1) then 
        read(value,*,err=100) zrep2
      elseif (index(line,'zdih=').eq.1) then 
        read(value,*,err=100) zdih
      elseif (index(line,'c0=').eq.1) then 
        read(value,*,err=100) c0

!+------------------------------------------------+
!| Parameters for cutoff functions f(r) and zz(r) |
!+------------------------------------------------+
      elseif (index(line,'zlow=').eq.1) then 
        read(value,*,err=100) zlow
      elseif (index(line,'zhigh=').eq.1) then 
        read(value,*,err=100) zhigh
      elseif (index(line,'zalpha=').eq.1) then 
        read(value,*,err=100) zalpha

      elseif (index(line,'flow=').eq.1) then 
        read(value,*,err=100) flow
      elseif (index(line,'fhigh=').eq.1) then 
        read(value,*,err=100) fhigh
      elseif (index(line,'falpha=').eq.1) then 
        read(value,*,err=100) falpha

      elseif (index(line,'bondcutoff=').eq.1) then 
        read(value,*,err=100) bondcutoff
      
!+-----------------------------------------------------+
!| These control values are stored in single variables |
!+-----------------------------------------------------+
      elseif (index(line,'ntakof=').eq.1) then
        read(value,*,err=100) ntakof
      elseif (index(line,'nprint=').eq.1) then 
        read(value,*,err=100) nprint
      elseif (index(line,'nsnap=').eq.1) then 
        read(value,*,err=100) nsnap

      elseif (index(line,'computeshear').eq.1) then 
        computeshear=.true.
      elseif (index(line,'shear=').eq.1) then 
        read(value,*,err=100) shear

      elseif (index(line,'nolinear').eq.1) then 
        nolinear=.true.
      elseif (index(line,'nodihedral').eq.1) then 
        nodihedral=.true.
      elseif (index(line,'norepulsion').eq.1) then 
        norepulsion=.true.

      elseif (index(line,'calcstress').eq.1) then 
        calcstress=.true.
      elseif (index(line,'smin=').eq.1) then 
        read(value,*,err=100) smin
      elseif (index(line,'smax=').eq.1) then 
        read(value,*,err=100) smax

      elseif (index(line,'cyclo=').eq.1) then 
        read(value,*,err=100) cyclo

      elseif (index(line,'nslab=').eq.1) then 
        read(value,*,err=100) nslab
      elseif (index(line,'nswap=').eq.1) then 
        read(value,*,err=100) nswap

      elseif (index(line,'ifix=').eq.1) then 
        read(value,*,err=100) ifix

      elseif (index(line,'newgcutoff').eq.1) then 
        newgcutoff=.true.
      elseif (index(line,'usedihedral2').eq.1) then 
        usedihedral2=.true.
      elseif (index(line,'usedihedral4').eq.1) then 
        usedihedral4=.true.
      elseif (index(line,'norings').eq.1) then 
        norings=.true.
      elseif (index(line,'static').eq.1) then 
        static=.true.
      elseif (index(line,'steepestdescent').eq.1) then 
        steepestdescent=.true.
      elseif (index(line,'xbspbc').eq.1) then 
        xbspbc=.true.
      elseif (index(line,'cellneighbour').eq.1) then 
        cellneighbour=.true.

      elseif (index(line,'special=').eq.1) then 
        special=.true.
	namespecial=value

!+---------------------------------------------+
!| The token `run' indexes the array variables |
!+---------------------------------------------+
      elseif (index(line,'run').eq.1) then 
        npass=npass+1
	do i=1,NVAR
	  varlist(npass,i)=varlist(npass-1,i)
	end do

!+---------------------------------------------+
!| These control values are stored in an array |
!+---------------------------------------------+
      elseif (index(line,'h=').eq.1) then 
        read(value,*,err=100) varlist(npass,1)
      elseif (index(line,'nstep=').eq.1) then 
        read(value,*,err=100) varlist(npass,2)
      elseif (index(line,'temp=').eq.1) then 
        read(value,*,err=100) varlist(npass,3)
      elseif (index(line,'therm=').eq.1) then 
        read(value,*,err=100) varlist(npass,4)
      elseif (index(line,'gr=').eq.1) then 
        read(value,*,err=100) varlist(npass,5)
      elseif (index(line,'msd=').eq.1) then 
        read(value,*,err=100) varlist(npass,6)

!+------------------------------+
!| If no match we have an error |
!+------------------------------+
      elseif (line(1:1).ne.';') then
        error=.true.
      end if
      return

 100  error=.true.
      end

      subroutine linear(i)

      include 'common.f90'

      dimension ff(2),rr(2),dgg(2),dff(2)
      dimension rx(2,3),dz(2,3)

      if (nolinear)     return
      if (zz(i).gt.3.0) return
      
      do jj=1,num(i)
      j=near(i,jj)
      rij=dr(i,jj)
      if ((zz(j).lt.4.0).and.(rij.gt.flow).and.(rij.lt.c0)) then

        do kk=1,num(i)
        if ((kk.ne.jj).and.(dr(i,kk).lt.fhigh)) then

	  finiteforce(jj)=.true.
	  finiteforce(kk)=.true.

!+----------------------------+
!| setup vectors: 1=ij , 2=ik |
!+----------------------------+
	  do ind=1,3
	    rx(1,ind)=dxdr(i,jj,ind)
	    rx(2,ind)=dxdr(i,kk,ind)
	  end do

	  rr(1)= dr(i,jj)
	  rr(2)= dr(i,kk)
	  cc= rr(1)-c0

	  ff(1)= (1.0-f(i,jj)) * cc*cc
	  ff(2)=      f(i,kk)
	  ff2= ff(1) * ff(2)

	  dff(1)= -df(i,jj)*cc*c!+ (1.0-f(i,jj))*2.0*cc
	  dff(2)=  df(i,kk)

	  gg= g2(i) * g(j)
	  dgg(1)= dzz(i,jj) * (dg2(i)*g(j) + g2(i)*dg(j))
	  dgg(2)= dzz(i,kk) *  dg2(i)*g(j)

!+---------------------------------------------------------------------+
!| g2(Zi) * g(Zj) * [1 - (ahat . chat)^2] * ff(a)*(1-ff(c)) * (c-c0)^2 |
!+---------------------------------------------------------------------+
          do k1=1,2                  ! k1 refers to a vector
            k2= 3-k1                 ! k2=k1+1 (mod 2)

	    dot=0.0
	    do ind=1,3
	      dot=dot + rx(k1,ind)*rx(k2,ind)
	    end do

	    dz1= (1.0-dot*dot) * ff(k2) * (dgg(k1)*ff(k1) + gg*dff(k1))
	    do ind=1,3
	      dz2= -2.0*dot/rr(k1) * (rx(k2,ind) - dot*rx(k1,ind))
	      dz(k1,ind)= rx(k1,ind)*dz1 + dz2*ff2*gg
	    end do
          end do

	  z(i)=z(i) + zrep2 * gg * (1.0-dot*dot) * ff2
          do ind=1,3
	    dzdx(jj,ind)=dzdx(jj,ind) + zrep2*dz(1,ind)
	    dzdx(kk,ind)=dzdx(kk,ind) + zrep2*dz(2,ind)
          end do

!+----------------------------------+
!| neighbours of i: easy derivative |
!+----------------------------------+
	  do nni=1,num(i)
	  if ((nni.ne.jj).and.(nni.ne.kk).and.(dr(i,nni).lt.zhigh)) then
	    finiteforce(nni)=.true.
	    fac= zrep2 * dg2(i)*dzz(i,nni) * g(j) * (1.0-dot*dot) * ff2
	    do ind=1,3
	      dzdx(nni,ind)=dzdx(nni,ind) + fac*dxdr(i,nni,ind)
	    end do
	  end if
	  end do

!+----------------------------------+
!| neighbours of j: easy derivative |
!+----------------------------------+
	  do nnj=1,num(j)
	  if ((near(j,nnj).ne.i).and.(dr(j,nnj).lt.zhigh)) then
	    finiteforce2(jj,nnj)=.true.
	    fac= zrep2 * dg(j)*dzz(j,nnj) * g2(i) * (1.0-dot*dot) * ff2
	    do ind=1,3
	      dzdxx(jj,nnj,ind)=dzdxx(jj,nnj,ind) + fac*dxdr(j,nnj,ind)
	    end do
	  end if
	  end do

        end if
        end do
      end if
      end do

      end

subroutine getforce(forcedim, force, energytotal)

    include "common.f90"
    
    integer forcedim,energydim
    real*8 force(forcedim)
    real*8, intent(out) :: energytotal
    
    do i=1,natom
        do ind=1,3
            force((i-1)*3 + ind) = fx(i,ind)
!            if(i==1) then
!                print *, i,"fortran force",fx(i,ind),force((i-1)*3 + ind)
!            end if
!            if(i==2) then
!                print *, i,"fortran force",fx(i,ind),force((i-1)*3 + ind)
!            end if
!            if(i==natom) then
!                print *, i,"fortran force",fx(i,ind),force((i-1)*3 + ind)
!            end if
!            if(i==natom-1) then
!                print *, i,"fortran force",fx(i,ind),force((i-1)*3 + ind)
!            end if
        end do    
    end do
    energytotal = pe

    !print *,"energytotal ", energytotal

end subroutine getforce

      subroutine printav

      include "common.f90"

      nloop=min(nloop,nstep)

      write(6,100) nloop,tav/dfloat(nloop)
      write(6,110) nrescale
      write(6,120) ELOSTtherm

 100  format(/,'Average Temp. over last ',I7,' steps : ',F9.2,' (K)')
 110  format('Number of thermostat rescales: ',I5)
 120  format('Energy removed by thermostat:',1P,E10.2,' eV')

      end

      subroutine printstatus

      include "common.f90"

!+-------------------+
!| Decision to print |
!+-------------------+
      if (mod(numstep,nprint).ne.0) return

      call properties
      etot= eke + pe + elosttherm

      xmsd=0.0
      zav=0.0
      sp1frac=0
      sp2frac=0
      sp3frac=0

      do i=1,natom
	zav=zav + z(i)
	do ind=1,3
          xmsd=xmsd + (x(i,ind) - x0(i,ind))**2
	end do

        ii=0
	do jj=1,num(i)
	  if (dr(i,jj).lt.bondcutoff) ii=ii+1
	end do
	if (ii.eq.2) sp1frac=sp1frac+1
	if (ii.eq.3) sp2frac=sp2frac+1
	if (ii.eq.4) sp3frac=sp3frac+1
      end do
      xmsd=xmsd/dfloat(natom)
      zav=zav/dfloat(natom)
      sp1frac= 100.0*sp1frac/dfloat(natom)
      sp2frac= 100.0*sp2frac/dfloat(natom)
      sp3frac= 100.0*sp3frac/dfloat(natom)

      if (nloop.le.nprint) then
        write(6,200)
        write(6,210)
        write(6,220)
      end if


      write(6,300) numstep,t*timetau
      write(6,310) pe,etot
      write(6,320) tempk
      write(6,330) xmsd
      write(6,340) zav
      write(6,350) sp1frac
      write(6,350) sp2frac
      write(6,350) sp3frac
      write(6,360) mv
!    if (.not.calcstress) pressure=0.0
      write(6,370) pressure

      call flush(6)

 200  format(/)
 210  format('step  time(ps)  PE(eV)   Etot(eV)',/)
 220  format('   Temp(K) MSD(Ang) Zav  %sp %sp2 %sp3  MVtot P(GPa)',/)
!  1P statements make first digit in exponential notation non-zero
 300  format(I8.8,1X,1P,E9.3,/)
 310  format(1X,F14.3,1X,F14.3)
 320  format(1X,F8.2)
 330  format(1X,1P,E9.3)
!340  format($,1X,1P,E9.3)
 340  format(1X,F5.2)
 350  format(1X,F5.1)
 360  format(1X,F8.3)
 370  format(  1X,1P,E10.4)

      end

!***********************************************************************

!    call defaults    <defaults needed for readinput go here>
!    call readinput
!    call checkinput  <cleaning up after readinput done here>

!Token for each variable: eg. nstep=500
!Equals sign separates token and argument
!Semi-colon and newline separate commands
!Tabs and spaces are treated as whitespace
!Remaining text on line after '#' ignored
!Include directive using #include= <filename>

!***********************************************************************

      subroutine readinput

      include "common.f90"

      character*256 remspace,filename(100),line,value
      logical       error,errorflag

!+--------------------------------------------+
!| line 100: read new file                    |
!| line 200: read new line                    |
!| line 300: read new entry (on current line) |
!+--------------------------------------------+

      n=6
      errorflag=.false.
      if (iargc().ne.1) stop ">>> No input file <<<"
      call getarg(1,value)

 100  n=n+1
      filename(n)=value
      open(unit=n,file=filename(n),status='old')

 200  read(n,'(a256)',end=400) line

 300  line=remspace(line)

      value=line(index(line,'=')+1:)
      value=remspace(value)
      nsemi=index(value,';')
      if (nsemi.ne.0) value=value(1:nsemi-1)

      if (line(1:9).eq."#include=") goto 100
      if (line(1:1).eq."#")         goto 200
       
      !print *,"call parse", line,value,error
      call parse(line,value,error)

      if (error) then
        errorflag=.true.
        write(6,310) filename(n)(1:60)
        write(6,320) line(1:60)

 310    format('Error in file: ',a60)
 320    format('  Can''t understand: ',a60)
      end if

!+--------------------------------------------------+
!| Semi-colons separate multiple commands on a line |
!+--------------------------------------------------+
      nsemi=index(line,';')
      if (nsemi.ne.0) then
        line=line(nsemi+1:)
	goto 300   ! read more commands on current line
      else
        goto 200   ! read new line
      end if

!+-----------------------------------------------------+
!| If nested via #include then return to previous file |
!+-----------------------------------------------------+
 400  close(unit=n)
      n=n-1
      if (n.gt.6) goto 200

      if (errorflag) stop
      end

      subroutine distance

      include "common.f90"

      dimension dxx(3)

!+---------------------------+
!| Clear energies and forces |
!+---------------------------+
      u2=0.0
      u3=0.0
      udih=0.0

      do i=1,natom
	do ind=1,3
          fx(i,ind)=0.0d0
	end do
      end do

!+-------------------------------+
!| Calcdistances and components |
!+-------------------------------+
      do loop=1,npair
        i=ipair(loop)
        j=jpair(loop)

	ii=inum(loop)
	jj=jnum(loop)

	do ind=1,3
          delta= x(i,ind) - x(j,ind)
          dxx(ind)=delta - box(ind)*dnint(delta/box(ind))
	end do

!This if-block for non-orthogonal coordinate system
        if (computeshear) then
	  dxx(2)=dxx(2) + shear*dxx(3)
	endif

	drr=0.0
	do ind=1,3
	  drr=drr + dxx(ind)*dxx(ind)
          dx(i,ii,ind)=  dxx(ind)
          dx(j,jj,ind)= -dxx(ind)
	end do
	drr=sqrt(drr)

	dr(i,ii)= drr
	dr(j,jj)= drr

	do ind=1,3
	  dxdr(i,ii,ind)= dx(i,ii,ind)/drr
	  dxdr(j,jj,ind)= dx(j,jj,ind)/drr
        end do
      end do

      end

      subroutine writegr

      include "common.f90"

      dimension rho(NGR)

!+-------------------+
!| Decision to print |
!+-------------------+
      if (mod(numstep,nprint).ne.0) return

!+----------------------+
!|  Write g(r) to file  |
!+----------------------+
      open(unit=9,file='gr.out',status='unknown')
      avrho=dfloat(natom)/(box(1)*box(2)*box(3))

      do i=1,numbin
        r= (i-0.5)*widthbin
	fac= dfloat(natom) * 4.0*pi*r*r * widthbin

        do j=1,NGR
          if (nframe(j).eq.0) then
	    rho(j)=0.0
	  else
	    rho(j)=2.0*nbin(j,i)/(fac*dfloat(nframe(j)))
	  end if
	end do

	write(9,100) r,(rho(j)/avrho,j=1,NGR)
 100    format(5f10.4)
      end do

      close(unit=9)
      end

      subroutine density

      include "common.f90"

      volm=vol*1e-30
      rho=dfloat(natom)*amass/volm

      write(6,100)
      write(6,110) box(1)
      write(6,120) box(2)
      write(6,130) box(3)
      write(6,140) volm*1e27
      write(6,150) rho/1000

 100  format(/,'System Size')
 110  format(' XBOX: ',F8.2,' Ang.')
 120  format(' YBOX: ',F8.2,' Ang.')
 130  format(' ZBOX: ',F8.2,' Ang.')
 140  format(' Volume: ',F6.2,' cubic_nanometres')
 150  format(' Density: ',F5.3,' g/cc')

      end

      subroutine defaults

      include "common.f90"

!These defaults are according to 
!  a) carbon/edip/param,
!  b) carbon/edip/run4/all4o, and
!  c) carbon/edip/potential

!Two-body potential parameters
      aa=20.0853862863495
      bb=0.827599951322299
      beta=0.0490161172713279
      sigma=1.25714643580808
      a1=1.89225338775144
      a2=0.169794491000172

!Three-body potential parameters
      gamma=1.2406975366223
      xlam=53.7116179513016
      qq=3.5
      xmu=0.25
      pilam=0.0

!Counting the coordination
      zlow=1.46
      zhigh=2.274108
      zalpha=1.544583

      flow=zlow
      fhigh=2.0
      falpha=zalpha

!Pi-bonding parameters
      zdih=0.30
      zrep=0.04
      zrep2=0.04
      c0=3.2

!Coordination cutoff
      bondcutoff=1.80

!Control File defaults
      npass=0

      varlist(0,1)=0.05   ! h
      varlist(0,2)=1000   ! nstep
      varlist(0,3)=300    ! temp
      varlist(0,4)=1      ! therm
      varlist(0,5)=1      ! gr
      varlist(0,6)=1      ! msd

      computeshear=.false.
      shear=0.0

      nolinear=.false.
      nodihedral=.false.
      norepulsion=.false.

      usedihedral2=.false.
      usedihedral4=.false.
      newgcutoff=.false.
      steepestdescent=.false.
      xbspbc=.false.
      cellneighbour=.false.

      cyclo=-1.0

      smin=0.0
      smax=-1.0
      calcstress=.false.

      norings=.false.
      special=.false.
      static=.false.

      ifix=0

      nswap=0
      nslab=10


      !write(*,*) "end edip defaults"
      end

      program carbon_edip

      include "common.f90"

      call printtime(1)

!+-------------------+
!| Read control file |
!+-------------------+
      call defaults
      call readinput
      call checkinput
!disable stress calcs in parallelized version (not correctly coded)
      calcstress = .false.   
      call printinput

!+-----------------------------------+
!| Read coordinate file & initialise |
!+-----------------------------------+
      call constants
      call readcoords
      call init
      call density

      !if (special) call runspecial

!+-----------+
!| Main loop |
!+-----------+
      do ipass=1,npass
        h=varlist(ipass,1)
        nstep=varlist(ipass,2)
        startt=varlist(ipass,3)
        itherm=varlist(ipass,4)
	igr=varlist(ipass,5)
	imsd=varlist(ipass,6)

        tav=0.0
        vflag=1.0
        nrescale=0

        do nloop=1,nstep
          call verlet
	  call distribution
          call therm
          call conductivity
          call neighbour

          call writexbs
          call printstatus
          call writetheta
          call writegr
        end do

        call printav
	call resetmsd
      end do

!+-------------+
!| Cleaning up |
!+-------------+
      call writestress
      call writecoords
      call printrings
      call printfinish
      call printtime(2)

      end
 

      subroutine conductivity

      include 'common.f90'

      integer   slab_atoms
      dimension slab_atoms(MAXSLAB),slab_ke(MAXSLAB),slab_temp(MAXSLAB)

      save swap_ke

      if (nswap.eq.0)              return
      if (mod(numstep,nswap).ne.0) return

! 	    Write header line for first line of output
      if (numstep.eq.nswap) then
        swap_ke=0.0

        open(unit=8,file='thermal.out',status='unknown')
        area=box(2)*box(3)
        write(8,100) nslab,nswap,area,box(1)
        close(unit=8)
 100    format('# ',I3,1x,I4,1x,F9.3,1x,F9.3)
      end if

! 	    Cold slab = slab number 1
! 	    Hot slab = slab in the middle

      hot_ke=-1.0
      cold_ke=1000.0
      xslab= box(1)/nslab
      middle=nslab/2+1

      do loop=1,nslab
        slab_ke(loop)=0.0
        slab_atoms(loop)=0
      end do

      do i=1,natom
        xx= x(i,1)-box(1)*dnint(x(i,1)/box(1))  ! projects to [-L/2:+L/2]
        if (xx.lt.0.0) xx=xx+box(1)             ! projects to [0:L]
        islab=int(xx/xslab)+1
        if (islab.gt.nslab) islab=nslab         ! just in case xx=nslab+1

        atom_ke=0.5*(vx(i,1)**2+vx(i,2)**2+vx(i,3)**2)
        slab_ke(islab)=slab_ke(islab)+atom_ke
        slab_atoms(islab)=slab_atoms(islab)+1

        if ((islab.eq.1).and.(atom_ke.gt.hot_ke)) then
          ihot=i
          hot_ke=atom_ke
        endif

        if ((islab.eq.middle).and.(atom_ke.lt.cold_ke)) then
          icold=i
          cold_ke=atom_ke
        endif
      end do

! 	    Check that the swap is correct
        ehot=vx(ihot,1)**2+vx(ihot,2)**2+vx(ihot,3)**2
        ecold=vx(icold,1)**2+vx(icold,2)**2+vx(icold,3)**2
      if(ehot.le.ecold) then
        write(6,*) 'warning, a velocityswap in the wrong direction'
      endif

! 	    Swapping the velocities of the hot and cold atoms
      do ind=1,3
        vold=vx(ihot,ind)
        vx(ihot,ind)=vx(icold,ind)
        vx(icold,ind)=vold
      end do
      vflag=1.0

      swap_ke=swap_ke + hot_ke - cold_ke

! 	    Adjust KE of cold & hot slabs, and convert to Kelvin
      slab_ke(1)= slab_ke(1)           - hot_ke + cold_ke
      slab_ke(middle)= slab_ke(middle) + hot_ke - cold_ke

      do loop=1,nslab
        slab_temp(loop)=slab_ke(loop)/dfloat(slab_atoms(loop)) * tfac
      end do

! 	    Write temperature of slabs to file
      open(unit=8,file='thermal.out',status='unknown',access='append')
      tnow=numstep*h*timetau
      write(8,110) tnow,swap_ke,(slab_temp(loop),loop=1,nslab)
      close(unit=8)

 110  format(F9.3,1X,F9.3,999(1X,F7.2))

      end

! -*- f90 -*-
      implicit double precision (a-h,o-z)

      double precision mv
      
      parameter (NMAX=10000,NNN=100,NP=INT(NNN*NMAX*0.5))
      parameter (NUMBIN=600,WIDTHBIN=0.01,NGR=2,NVAR=6)
      parameter (NUMBIN2=181,WIDTHBIN2=1.0)
      parameter (MAXCELL1=100,MAXCELL=100,MAXINCELL=50)
!      parameter (MAXCELL=150,MAXINCELL=50)
      parameter (MAXSLAB=1000)
      parameter (MAXCPU=32)
      parameter (pi=3.1415926536)
      parameter (AMASS=12.01*1.66e-27)
      parameter (BOLTZMANN=8.617e-5) 
      parameter (tau1=-6.0*2.5, tau2=6.0)

      character*80 namespecial

      logical finiteforce
      logical finiteforce2

      logical static
      logical special
      logical norings
      logical computeshear
      logical usedihedral2
      logical usedihedral4
      logical newgcutoff
      logical calcstress
      logical steepestdescent
      logical xbspbc
      logical cellneighbour

      logical nolinear
      logical nodihedral
      logical norepulsion

      integer*4 ncpu, icpu
      integer*4 OMP_GET_MAX_THREADS
      integer*4 OMP_GET_THREAD_NUM

      !!! consider 0.025eV/300K !!!
      !parameter (TIMETAU=1e12*1e-10*(AMASS/1.6e-19)**0.5)
      !definition of timetau has moved to constants.f

      common /PARAM1/ aa,bb,beta,sigma,a1,a2
      common /PARAM2/ qq,xlam,xmu,gamma,pilam
      common /PARAM3/ zlow,zhigh,zalpha
      common /PARAM4/ flow,fhigh,falpha
      common /PARAM5/ zdih,zrep,zrep2,c0,bondcutoff

      common /ENTRY/  varlist(0:100,NVAR),npass,nsnap

      common /ELOST/  elosttherm,nrescale
      common /STATE/  u2,u3,udih,pe,tempk,eke,mv,pestart,ekestart,tav
      common /STEPS/  t,h,numstep,istep,nstep,nloop,nprint,itherm
      common /EXTRA/  timetau,tfac,vflag,startt,ntakof,iseed,imsd

      common /SHEAR1/ computeshear
      common /SHEAR2/ shear

      common /FLAGS1/ nolinear,nodihedral,norepulsion,usedihedral2
      common /FLAGS2/ norings,static,special
      common /FLAGS3/ newgcutoff,calcstress,usedihedral4
      common /FLAGS4/ steepestdescent,xbspbc,cellneighbour
      common /FLAGS5/ namespecial

      common /NATOM/  natom
      common /BOXL/   box(3)
      common /ZZZZ/   z(NMAX), zz(NMAX)
      common /ZDERV/  dzdx(NNN,3), dzdxx(NNN,NNN,3)
      common /ZFORC/  finiteforce(NNN), finiteforce2(NNN,NNN)
      common /COORD/  x(NMAX,3), vx(NMAX,3), x0(NMAX,3)
      common /DRXYZ/  dr(NMAX,NNN),dx(NMAX,NNN,3),dxdr(NMAX,NNN,3)
      common /STRES/  totstr(3,3),pressure,biaxial,smin,smax,nstress
      common /BOXVOL/ vol
      common /COMM1/  fx(NMAX,3)

      common /CELLS/  ncell(MAXCELL1,MAXCELL,MAXCELL), numcells(3)
      common /CELLS2/  icell(MAXCELL1,MAXCELL,MAXCELL,MAXINCELL)
      common /PAIRS/  ipair(NP),jpair(NP),inum(NP),jnum(NP),npair
      common /INEAR/  near(NMAX,NNN),num(NMAX),kron(NNN,NNN)

      common /ZCYCL/  f(NMAX,NNN), df(NMAX,NNN), dzz(NMAX,NNN)
      common /GATOM/   g(NMAX),  g2(NMAX),  g3(NMAX)
      common /DGATM/  dg(NMAX), dg2(NMAX), dg3(NMAX)
      common /COM01/  cyclo

      common /GRDAT/ nbin(NGR,NUMBIN),nframe(NGR),igr
      common /ANGLE/ nbin2(NGR,4,NUMBIN2)
      common /FIXED/ ifix
      common /CONDU/ nslab,nswap

      common /EREDC/  u2i(MAXCPU), u3i(MAXCPU), udihi(MAXCPU)
      common /FREDC/  fxx(NMAX,3,MAXCPU)


!$OMP THREADPRIVATE (/ZDERV/,/ZFORC/)

      SUBROUTINE CONSTANTS

      INCLUDE "common.f90"

      timetau=1e12*1e-10*sqrt(AMASS/1.6e-19)

      WRITE(6,100)
      WRITE(6,110) 
      WRITE(6,120) 
      WRITE(6,130) AMASS
      WRITE(6,140) timetau*1000

 100  FORMAT(/,'Reduced Units:')
 110  FORMAT(' ENERGY: 1 eV')
 120  FORMAT(' LENGTH: 1 Angstrom')
 130  FORMAT(' MASS: ',1p,E9.3,' kg')
 140  FORMAT(' TIME: ',F6.2,' fs')

      END

      subroutine runspecial

      include "common.f90"

      parameter (zero=0.0d0)

      write(6,50) namespecial(1:20)
 50   format(/,'Special Run: ',a20)

      if (namespecial(1:3).eq.'gra') goto 100
      if (namespecial(1:3).eq.'lin') goto 100
      if (namespecial(1:3).eq.'tmm') goto 200
      if (namespecial(1:3).eq.'ben') goto 200
      if (namespecial(1:3).eq.'two') goto 300
      stop 'Bad Argument of special'

!+-----------------------------------------------------------+
!| Graphite/diamond and graphite/linear activiation barriers |
!+-----------------------------------------------------------+
 100  if (namespecial(1:3).eq.'gra') then
	rmin=1.54
	bmin=1.42
	theta0=109.5
      else
	rmin=1.42
	bmin=1.32
	theta0=120.0
      endif
      b0=rmin

      do r=rmin,3.20,0.025
        call minimize(r,b0,theta0,bmin,tmin,zmin)
        write(6,110) r,b0,theta0,pe/natom,zmin
 110    format(3f10.3,2f15.9)

        call makespecial(r,b0,theta0)
        call writexbs
        numstep=numstep+1
      end do
      return

!+---------------------------------------------+
!| Bensan's TMM and benzene out-of-plane bends |
!+---------------------------------------------+
 200  do theta=0,15,1
        call makespecial(zero,zero,theta)
 	call energy

	if (numstep.eq.0) pemin=pe
 	write(6,*) theta,pe-pemin
 	call writexbs
	numstep=numstep+1
      end do
      return

!+---------------------------+
!| Bending of a linear chain |
!+---------------------------+
 300  do theta=0,120,5
        call makespecial(zero,zero,theta)
 	call energy

	if (numstep.eq.0) pemin=pe
 	write(6,*) theta,pe-pemin,z(2)
 	call writexbs
	numstep=numstep+1
      end do
      end

!****************************************************

      subroutine minimize(r,b0,theta0,bmin,tmin,zmin)

      include "common.f90"

      pemin=999

      b1=b0
      b2=max(b0-0.025,bmin)

      theta1=theta0
      theta2=max(theta0-3.0,90.0d0)

      do b=b1,b2,-0.005
        do theta=theta1,theta2,-0.5
	  call makespecial(r,b,theta)
	  call energy

	  if (pe.lt.pemin) then
	    pemin=pe
	    zmin=z(1)
	    b0=b
	    theta0=theta
	  end if
        end do
      end do

      pe=pemin
      end

subroutine test()
    integer*4 OMP_GET_MAX_THREADS
    integer a
    integer*4 ncpu
    !$      ncpu=OMP_GET_MAX_THREADS()
    print *, "fortran ncpus",ncpu
    
    a = 1
    print *,a
end subroutine test

      subroutine passcoords(natomin,boxxin,boxyin,boxzin,rdim,r)
    
      include "common.f90"
 
      integer natomin,rdim
      real*8 boxxin,boxyin,boxzin
      real*8 r(rdim)

      natom = natomin
      box(1) = boxxin
      box(2) = boxyin
      box(3) = boxzin

      !print *,"fortran natom",natom,rdim,"box",box(1),box(2),box(3)
      t=0.0
      istep=0
      do i=1,natom
        do ind=1,3
          x(i,ind)=r((i-1)*3 + ind)
          vx(i,ind)=0.0
          x0(i,ind)=x(i,ind)
          !print *, "fortran position ",x(i,ind)
        end do
      end do
      
!+-----------------+
!| Kronecker Delta |
!+-----------------+
      do i=1,NNN
        do j=1,NNN
          if (i.ne.j) kron(i,j)=0.0
          if (i.eq.j) kron(i,j)=1.0
        end do
      end do

      end subroutine passcoords

      subroutine neighbour

      include "common.f90"

      parameter (rskin=0.10)
      dimension xold(nmax,3), widthcell(3), ipos(3)
      save      xold

!+--------------------------------------------+
!|  Check to see if list needs recalculation  |
!+--------------------------------------------+
      if ((numstep.ne.0).and.(.not.special)) then
        rmovemax=0.0
        do i=1,natom
          rmove=0.0
          do ind=1,3
            rmove=rmove + (x(i,ind)-xold(i,ind))**2
          end do
          rmovemax=max(rmovemax,rmove)
        end do

        if (dsqrt(rmovemax).lt.rskin) return
      end if

!+------------------------+
!|  Clear existing lists  |
!+------------------------+
      rcut=c0+2.0*rskin
      if (special) rcut=c0

      npair=0
      do i=1,natom
        num(i)=0
      end do

      if (cellneighbour) then
!+-------------------------------------------------+
!|  O(N) loop to create the list of indexed pairs  |
!+-------------------------------------------------+
        ! Identify the number of cells for each dimension
        do ind=1,3
          numcells(ind)=int(box(ind)/(rcut+0.1))
          widthcell(ind)=box(ind)/real(numcells(ind))

          if (numcells(1).gt.MAXCELL1) stop 'Increase MAXCELL1'
          if (numcells(2).gt.MAXCELL) stop 'Increase MAXCELL'
          if (numcells(3).gt.MAXCELL) stop 'Increase MAXCELL'
        end do

        ! Clear array containing number of atoms in each cell
        do ix=1,numcells(1)
          do iy=1,numcells(2)
            do iz=1,numcells(3)
              ncell(ix,iy,iz)=0
            end do
          end do
        end do

        ! Populate atoms into the cells (map coordinate into [0,box) first)
        do i=1,natom
          do ind=1,3
            xx= x(i,ind)-box(ind)*dnint(x(i,ind)/box(ind))+0.5*box(ind)
            ipos(ind)=int(xx/widthcell(ind))+1
            if (ipos(ind).gt.numcells(ind)) ipos(ind)=numcells(ind)
          end do

          numincell= ncell(ipos(1),ipos(2),ipos(3)) + 1
          if (numincell.gt.MAXINCELL) stop 'Increase MAXINCELL'

          ncell(ipos(1),ipos(2),ipos(3))= numincell
          icell(ipos(1),ipos(2),ipos(3),numincell) = i
        end do

        ! Loop over cells
        do ix=1,numcells(1)
          do iy=1,numcells(2)
            do iz=1,numcells(3)
              ! Loop over atoms in the cell
              do iloop=1,ncell(ix,iy,iz)
                i=icell(ix,iy,iz,iloop)

                call checkcell(i,ix,iy,iz,iloop+1) ! other atoms in the same cell

                ! This group of three have no unique inverses
                call checkcell(i,ix+1,iy,iz,1)     ! (1,0,0)
                call checkcell(i,ix,iy+1,iz,1)     ! (0,1,0)
                call checkcell(i,ix,iy,iz+1,1)     ! (0,0,1)

                ! This group of three have a single unique inverse each
                call checkcell(i,ix+1,iy+1,iz,1)   ! (1,1,0)
                call checkcell(i,ix+1,iy,iz+1,1)   ! (1,0,1)
                call checkcell(i,ix,iy+1,iz+1,1)   ! (0,1,1)

                call checkcell(i,ix-1,iy+1,iz,1)   ! (-1,1,0)
                call checkcell(i,ix+1,iy,iz-1,1)   ! (1,0,-1)
                call checkcell(i,ix,iy-1,iz+1,1)   ! (0,-1,1)

                ! This direction has three unique inverses
                call checkcell(i,ix+1,iy+1,iz+1,1)   ! (1,1,1)

                call checkcell(i,ix-1,iy+1,iz+1,1)   ! (-1,1,1)
                call checkcell(i,ix+1,iy-1,iz+1,1)   ! (1,-1,1)
                call checkcell(i,ix+1,iy+1,iz-1,1)   ! (1,1,-1)
              end do
            end do
          end do
        end do

!+---------------------------------------------------+
!|  O(N^2) loop to create the list of indexed pairs  |
!+---------------------------------------------------+
      else
        do i=1,natom-1
          do j=i+1,natom
            call checkrij(i,j)
          end do
        end do
      end if

!+-----------------------+
!| Check no NNN overflow |
!+-----------------------+
      numflag=0
      do i=1,natom
        if (num(i).gt.NNN) then
          numflag=1
          write(6,*) 'atom',i,' num(i)=',num(i)
        end if
      end do
      if (numflag.eq.1) stop 'Increase NNN'


!+----------------------------+
!|  Save current coordinates  |
!+----------------------------+
      do i=1,natom
        do ind=1,3
          xold(i,ind)=x(i,ind)
        end do
      end do

      end

      subroutine writestress

      include "common.f90"

      if (.not.calcstress) return
!    call stress(0)
      fac= 160.219 / vol / nstress

      write(6,*) 
      write(6,*) 'Volume [Ang^3]=',vol
      write(6,*) 'nstress=',nstress
      write(6,*)
      write(6,*) 'Stress Tensor [GPa]'
      write(6,100) 'X',(fac*totstr(1,ind),ind=1,3)
      write(6,100) 'Y',(fac*totstr(2,ind),ind=1,3)
      write(6,100) 'Z',(fac*totstr(3,ind),ind=1,3)

      write(6,*)
      write(6,*) 'Hydrostati!Pressure / Biaxial Stress [GPa]'
      write(6,*) pressure,biaxial

 100  format(4x,1a,3f15.7)

      end

      function remspace(value)

      character*256 remspace,value

      do 100 i=1,256
        if (value(i:i).eq.' ')      goto 100
        if (ichar(value(i:i)).eq.9) goto 100
        remspace=value(i:)
        return
 100  continue

      remspace="#"
      end

      subroutine writetheta

      include "common.f90"

      dimension values(NGR,4)

!+-------------------+
!| Decision to print |
!+-------------------+
      if (mod(numstep,nprint).ne.0) return

!+--------------------------------+
!|  Write nbin2 to file theta.out |
!+--------------------------------+
      open(unit=9,file='theta.out',status='unknown')

      do i=1,numbin2
        angle= (i-0.5)*widthbin2
	do j=1,4
	  do k=1,NGR
	    if (nframe(k).eq.0) then
	      values(k,j)=0.0
	    else
	      values(k,j)=nbin2(k,j,i)/dfloat(natom*nframe(k))
	    end if
	  end do
	end do
	write(9,100) angle,((values(k,j),j=1,4),k=1,NGR)
 100    format(F6.2,8F7.4)
      end do

      close(unit=9)
      end

       program random_atoms

       real rand

       write(6,100)
       write(6,110)
       read(5,*) boxx,boxy,boxz,ndens
       natom = nint(0.001*ndens*boxx*boxy*boxz)
 100   format('LATTICE: Random atoms generator  ')
 110   format('LATTICE: Enter x,y,z box dimensions and number density')
 120   format('LATTICE: Number Density= ',f6.3)
 130   format('BOX: box x= ',f6.3,'  box y= ',f6.3,'  box z= ',f6.3)

       iseed=31415
       dummy=rand(iseed)

       write(6,120) natom
       write(6,130) boxx,boxy,boxz

       open(unit=7,file='RESTART_random',status='unknown')
       write(7,*) 0, 0, natom
       write(7,*) boxx,boxy,boxz

       do i=0,natom-1
             call atom(boxx,boxy,boxz)
       end do

       close(unit=7)

       end

!**********************************************************************

       subroutine atom(boxx,boxy,boxz)

       real    rand
       real    boxx,boxy,boxz

       xdiff= 1.0*(rand()-0.5) * boxx
       ydiff= 1.0*(rand()-0.5) * boxy
       zdiff= 1.0*(rand()-0.5) * boxz

       write(7,100) xdiff, ydiff, zdiff
 100   format(3(f7.3,3x))
       end

      subroutine checkinput

      include "common.f90"

!+-------------------------------------+
!| Implied settings from logical flags |
!+-------------------------------------+
      if (special)      norings=.true.
      if (special)      npass=-1
      if (special)      nsnap=1

      if (static)       npass=-1
      if (usedihedral2) nodihedral=.true.
      if (usedihedral4) nodihedral=.true.


!+-----------------------------------+
!| Absence of token "run" is allowed |
!+-----------------------------------+
      if (npass.eq.0) then
        npass=1
	do i=1,NVAR
	  varlist(1,i)= varlist(0,i)
	end do
      endif

!+--------------------------------------+
!| Check control variables are sensible |
!+--------------------------------------+
      do i=1,npass
        itherm=int(varlist(i,4))
        igr=int(varlist(i,5))
        imsd=int(varlist(i,6))

	if ((itherm.lt.0).or.(itherm.gt.4)) then
	  stop 'itherm is out of range'
	elseif ((igr.lt.0).or.(igr.gt.NGR)) then
	  stop 'igr is out of range'
	elseif ((imsd.lt.0).or.(imsd.gt.1)) then
	  stop 'imsg is out of range'
	endif
      end do

      if (nslab.gt.MAXSLAB) stop 'Increase MAXSLAB'
      if (mod(nslab,2).ne.0) stop 'nslab must be even'
      if (nswap.ne.0) then
        if (npass.ne.1) stop 'npass must be one for thermal calc'
      end if


      end

      subroutine coordination(i)

      include 'common.f90'


      z(i)=zz(i)

!+----------------------------+
!| Setup neighbours of atom i |
!+----------------------------+
      do jj=1,num(i)
	if ((dr(i,jj).gt.zlow).and.(dr(i,jj).lt.zhigh)) then
	  finiteforce(jj)=.true.
	else
	  finiteforce(jj)=.false.
	end if
        do ind=1,3
          dzdx(jj,ind)=dzz(i,jj)*dxdr(i,jj,ind)
        end do
      end do

!+-------------------------------------+
!| Setup neighbours-of-neighbours of i |
!+-------------------------------------+
      do jj=1,num(i)
      do kk=1,num(near(i,jj))
        finiteforce2(jj,kk)=.false.
        do ind=1,3
          dzdxx(jj,kk,ind)=0.0
        end do
      end do
      end do

!+-------------------------------+
!| Call sp/sp2 terms if required |
!+-------------------------------+
      call dihedral(i)
      call repulsion(i)
      call linear(i)

      end

      subroutine repulsion(i)

      include 'common.f90'

      dimension ff(3),dff(3),dgg(3),rr(3),xk(3)
      dimension rx(3,3),dz(3,3)

      if (norepulsion)  return
      if (zz(i).gt.4.0) return

      do jj=1,num(i)
      j=near(i,jj)
      rij=dr(i,jj)
      if ((zz(j).lt.4.0).and.(rij.gt.flow).and.(rij.lt.c0)) then

        do kk=1,num(i)
        if ((kk.ne.jj).and.(dr(i,kk).lt.fhigh)) then

          do mm=kk+1,num(i)
          if ((mm.ne.jj).and.(dr(i,mm).lt.fhigh)) then

	    finiteforce(jj)=.true.
	    finiteforce(kk)=.true.
	    finiteforce(mm)=.true.

!+-----------------------------------+
!| setup vectors: 1=ij , 2=ik , 3=im |
!+-----------------------------------+
	    do ind=1,3
	      rx(1,ind)=dxdr(i,jj,ind)
	      rx(2,ind)=dxdr(i,kk,ind)
	      rx(3,ind)=dxdr(i,mm,ind)
	    end do

	    rr(1)=dr(i,jj)
	    rr(2)=dr(i,kk)
	    rr(3)=dr(i,mm)

	    cc=rr(1)-c0

!	    !!! next bit of code a hack to test shape of pi-pi repulsion
!	    qz=2.0
! 	    qexp= exp(-qz*cc*cc)
! 	    ffq= 1.0/qz * (1.0 - qexp)
! 	     ff(1)= (1.0-f(i,jj)) * ffq
!          dff(1)= (1.0-f(i,jj)) * 2.0*cc*qexp - df(i,jj)*ffq 

 	    ff(1)= (1.0-f(i,jj))*cc*cc
	    ff(2)=      f(i,kk)
	    ff(3)=      f(i,mm)
	    ff123= ff(1) * ff(2) * ff(3)

 	    dff(1)= -df(i,jj)*cc*c!+ (1.0-f(i,jj))*2.0*cc
	    dff(2)=  df(i,kk)
	    dff(3)=  df(i,mm)

	    gg= g3(i)*g(j)
	    dgg(1)= dzz(i,jj) * (dg3(i)*g(j) + dg(j)*g3(i))
	    dgg(2)= dzz(i,kk) *  dg3(i)*g(j)
	    dgg(3)= dzz(i,mm) *  dg3(i)*g(j)

!+-----------------------------------------------------------------------+
!| g3(Zi)*g(Zj) * (ahat . bhat x chat)^2 * f(a)*f(b)*(1-f(c)) * (c-c0)^2 |
!+-----------------------------------------------------------------------+
            do k1=1,3                  ! k1 refers to a vector
              k2= mod(k1  ,3) + 1      ! k2=k1+1 (mod 3)
              k3= mod(k1+1,3) + 1      ! k3=k1+2 (mod 3)

              xk(1)= rx(k2,2)*rx(k3,3) - rx(k2,3)*rx(k3,2)
              xk(2)= rx(k2,3)*rx(k3,1) - rx(k2,1)*rx(k3,3)
              xk(3)= rx(k2,1)*rx(k3,2) - rx(k2,2)*rx(k3,1)

              dot= rx(k1,1)*xk(1) + rx(k1,2)*xk(2) + rx(k1,3)*xk(3)

	      dz1= dot*dot*ff(k2)*ff(k3)* (dgg(k1)*ff(k1) + gg*dff(k1))
	      dz2= gg * ff123 * 2.0/rr(k1) * dot

	      do ind=1,3
	        dz(k1,ind)= rx(k1,ind)*(dz1 - dot*dz2) + dz2*xk(ind)
	      end do
            end do

	    z(i)=z(i) + zrep * gg * dot*dot * ff123
	    do ind=1,3
	      dzdx(jj,ind)=dzdx(jj,ind) + zrep*dz(1,ind)
	      dzdx(kk,ind)=dzdx(kk,ind) + zrep*dz(2,ind)
	      dzdx(mm,ind)=dzdx(mm,ind) + zrep*dz(3,ind)
            end do

!+----------------------------------+
!| neighbours of i: easy derivative |
!+----------------------------------+
	    do nni=1,num(i)
	      if ((nni.ne.jj).and.(nni.ne.kk).and.(nni.ne.mm)) then
	      if (dr(i,nni).lt.zhigh) then
		finiteforce(nni)=.true.
	        fac= zrep * dg3(i)*dzz(i,nni) * g(j) * dot*dot * ff123
		do ind=1,3
		  dzdx(nni,ind)=dzdx(nni,ind) + fac*dxdr(i,nni,ind)
		end do
	      end if
	      end if
	    end do

!+----------------------------------+
!| neighbours of j: easy derivative |
!+----------------------------------+
	    do nnj=1,num(j)
	      if ((near(j,nnj).ne.i).and.(dr(j,nnj).lt.zhigh)) then
		finiteforce2(jj,nnj)=.true.
	        fac= zrep * dg(j)*dzz(j,nnj) * g3(i) * dot*dot * ff123
		do ind=1,3
		 dzdxx(jj,nnj,ind)=dzdxx(jj,nnj,ind)+fac*dxdr(j,nnj,ind)
		end do
	      end if
	    end do

          end if
          end do
        end if
        end do
      end if
      end do

      end

      subroutine printtime(iflag)

      include "common.f90"

      character*24 date
      integer      tstart,time
      save         tstart

      call fdate(date)

      if (iflag.eq.1) then
        tstart=time()
        write(6,100) date
      else
	if (static) numstep=1
        tdiff= dfloat(time()-tstart)

        write(6,110) date
        write(6,120) tdiff/60
        write(6,130) int(tdiff/dfloat(natom*numstep)*1e6)
        write(6,140) numstep*h*timetau
      end if

 100  format(/,'Simulation begun ',A24)
 110  format(/,'Simulation completed ',A24)
 120  format('  wall-clock time: ',F7.2,' minutes')
 130  format('  performance: ',i6,' microseconds/atom/timestep')
 140  format('  simulation time: ',F7.2,' ps')

      end

      subroutine printfinish

      include "common.f90"
      ncpu=1
!$    ncpu=OMP_GET_MAX_THREADS()

      call properties
      etot=eke + pe + elosttherm
      etotstart=ekestart + pestart
      write(6,90) ncpu
      write(6,100) etotstart,pestart
      write(6,110) etot,pe
 90   format(  4X,'This job was run on ',I3,' CPUs')
 100  format(/,4X,'Etot/PE before = ',F14.3,3X,F14.3,' eV')
 110  format(  4X,'Etot/PE after  = ',F14.3,3X,F14.3,' eV')

      end

      subroutine therm

      include "common.f90"

      save temp0, dtherm

!+---------------------------------+
!| Decide what do do - if anything |
!+---------------------------------+
      if (steepestdescent) return

      if (nloop.eq.1) then
        if (numstep.eq.1) temp0= tempk
        if (itherm.eq.2) dtherm= (startt-temp0)/nstep
        if (itherm.eq.3) dtherm= (startt/temp0)**(1.0/nstep)
      end if

      if (itherm.eq.0) temp0=tempk
      if (itherm.eq.1) temp0=startt
      if (itherm.eq.2) temp0=temp0 + dtherm
      if (itherm.eq.3) temp0=temp0 * dtherm
      if (itherm.eq.4) call edgetherm

      if (itherm.eq.0)    return
      if (itherm.eq.4)    return
!    if (nloop.eq.nstep) return

!+--------------------------------------+
!| Do the velocity rescale as specified |
!+--------------------------------------+
      call properties
      tempfrac= abs(tempk/temp0 - 1.0)
      if (tempfrac.lt.1.5/sqrt(dfloat(natom-ifix))) return
!    if (tempfrac.lt.1.0/sqrt(dfloat(natom))) return

      vflag=1.0
      ekeold=eke
      tempkold=tempk
      vfac=dsqrt(temp0/tempk)

      do i=ifix+1,natom
        do ind=1,3
          vx(i,ind)=vx(i,ind)*vfac
        end do
      end do

!+-------------------------------------+
!| Find how much energy lost or gained |
!+-------------------------------------+
      call properties
      elosttherm=elosttherm + ekeold - eke
      nrescale=nrescale+1

      end

      subroutine energy

      include "common.f90"
      open(unit=7,file='energies.txt',status='unknown')

!+--------------------------------------+
!| Clear energies and compute distances |
!+--------------------------------------+
      u2=0.0
      u3=0.0
      udih=0.0

      call distnab
      call cutoff

      do i=1,natom
        call coordination(i)
	a12= a1 + a2*z(i)
	tau=1.0 - z(i)/12.0 * (1.0 + tanh(tau1+tau2*z(i)))

!+------------------+
!| Pair Interaction |
!+------------------+
        do jj=1,num(i)
        if (dr(i,jj).lt.a12-0.001) then

          rij=dr(i,jj)
          bond=exp(-beta*z(i)*z(i))
          pair = aa * (bb/rij**4 - bond) * exp(sigma/(rij-a12))
          write(7,*) rij, pair
          u2=u2 + pair

!+--------------------+
!| Triple Interaction |
!+--------------------+
          do kk=jj+1,num(i)
 	  if (dr(i,kk).lt.a12-0.001) then

	    cosi=0.0
	    do ind=1,3
	      cosi=cosi + dxdr(i,jj,ind)*dxdr(i,kk,ind)
	    end do

            arg12= gamma/(dr(i,jj)-a12) + gamma/(dr(i,kk)-a12)
            zexpgam=exp(arg12 - xmu*(z(i)-4.0)*(z(i)-3.0-0.069/xmu))
!          zexpgam=exp(arg12 - xmu*(z(i)-4.0)*(z(i)-3.0))
            theta= xlam/qq * (1.0 - exp(-qq*(cosi+tau)**2))
            triple = zexpgam*theta
            write(7,*)rij, triple/2.0
            write(7,*)dr(i,kk), triple/2.0
            u3=u3 + triple
        
	  end if
          end do   
!  kk
	end if
        end do
! neighbours
      end do
!  atom

      pe= u2 + u3 + udih
      close(unit=7)
      end
   

      subroutine distribution

      include "common.f90"

      dimension dxx(3)

!+-----------------------------------+
!| Decision to compute distributions |
!+-----------------------------------+
      if (igr.eq.0)             return
      if (mod(numstep,10).ne.0) return

      nframe(igr)=nframe(igr)+1

!+--------------------------------+
!| Accumulate distance statistics |
!+--------------------------------+

      do i=1,natom-1
        do j=i+1,natom
          do ind=1,3
            delta= x(i,ind) - x(j,ind)
            dxx(ind)=delta - box(ind)*dnint(delta/box(ind))
          end do

          rijsq=0.0
          do ind=1,3
            rijsq=rijsq + dxx(ind)*dxx(ind)
          end do
          rij=sqrt(rijsq)

          ibin=int(rij/widthbin)+1
          if (ibin.le.NUMBIN) nbin(igr,ibin)=nbin(igr,ibin)+1
        end do
      end do

!+-----------------------------+
!| Accumulate angle statistics |
!+-----------------------------+
      do i=1,natom
        nn=0
	do jj=1,num(i)
	  if (dr(i,jj).lt.bondcutoff) nn=nn+1
	end do

	do jj=1,num(i)
	if (dr(i,jj).lt.bondcutoff) then
	  do kk=jj+1,num(i)
	  if (dr(i,kk).lt.bondcutoff) then
	    cosi=0.0
	    do ind=1,3
	      cosi=cosi + dxdr(i,jj,ind)*dxdr(i,kk,ind)
	    end do

	    angle=acos(cosi)*180.0/pi
	    ibin=int(angle/widthbin2)+1
	    nbin2(igr,1,ibin)=nbin2(igr,1,ibin) + 1
	    if (nn.le.4) nbin2(igr,nn,ibin)=nbin2(igr,nn,ibin) + 1
	  end if
	  end do
	end if
	end do
      end do

      end
